#import <Foundation/Foundation.h>

int throw(id anObject)
{
	[NSException raise: NSGenericException
				format: @"This is an example"];
	return 0;
}

void rethrow(void)
{
	id pool = [NSAutoreleasePool new];
	id array = [NSArray new];
	@try
	{
		throw(array);
	}
	@catch (id e)
	{
		NSLog(@"Caught exception %@", e);
		e = [e retain];
		[pool drain];
		[e autorelease];
		pool = nil;
		@throw;
	}
	@finally
	{
		[array release];
		[pool drain];
	}
}

int main(void)
{
	[NSAutoreleasePool new];
	@try
	{
		rethrow();
	}
	@catch (NSException *e)
	{
		NSLog(@"Caught exception %@", e);
	}
	return 0;
}
