#import <Foundation/Foundation.h>


int main(void)
{
	[NSAutoreleasePool new];
	NSString *json = @"\
   {\
      \"Image\": {\
          \"Width\":  800,\
          \"Height\": 600,\
          \"Title\":  \"View from 15th Floor\",\
          \"Thumbnail\": {\
              \"Url\":    \"http://www.example.com/image/481989943\",\
              \"Height\": 125,\
              \"Width\":  \"100\"\
          },\
      },\
      \"IDs\": [116, 943, 234, 38793],\
      \"escapeTest\": \"\\\"\\u0001\"\
  }";
	NSData *jsonData =
		[json dataUsingEncoding: NSUTF8StringEncoding];
	NSError *e;
	id object =
	  [NSJSONSerialization JSONObjectWithData: jsonData
	                                  options: 0
	                                    error: &e];
	NSCAssert(nil == e, @"Failed to parse JSON");
	NSData *data =
	  [NSJSONSerialization dataWithJSONObject: object
	                                  options: NSJSONWritingPrettyPrinted
	                                    error: &e];
	NSCAssert(nil == e, @"Failed to export JSON");
	NSLog(@"object: %@", object);
	return 0;
}

